/*****************************************/
/*  Class Hopfield pattern learner       */
/*****************************************/

#include "CAssocmem.h"

/*****************************************/

/*-----------------------------------------------------------------------*\
    using namespace: ...
\*-----------------------------------------------------------------------*/

//using namespace Atma;
// NOT :)

// A lil' comment: this is an old version of the stuff: one should use exceptions and automatic stack unwinding
// for the class ( see www.relisoft.com -> tuts for info on automatic stack unwinding)

CAssocmem::CAssocmem()
{
    srand(time(NULL));
    
    weights     =NULL;
    treshold    =NULL;
    outputs     =NULL;
    nb_neurons  =NULL;
}

CAssocmem::CAssocmem(ULONG size)
{
    ULONG cpt;
    ULONG tmp;
    
    srand(time(NULL));
    
    nb_neurons  =size;
    treshold    =new int[size];
    
    if (treshold==NULL)
    {
        cerr << "Error allocating memory" << endl;
        nb_neurons  =0;
        weights     =NULL;
        outputs     =NULL;
        return;
    }
    
    outputs     =new int[size];
    
    if (outputs==NULL)
    {
        cerr << "Error allocating memory" << endl;
        nb_neurons  =0;
        weights     =NULL;
        delete[] treshold;
        treshold    =NULL;
        return;
    }

    weights     =new int*[size];
    
    if (weights==NULL)
    {
        cerr << "Error allocating memory" << endl;
        nb_neurons  =0;
        delete[] treshold;
        treshold    =NULL;
        delete[]  outputs;
        outputs     =NULL;
        return;
    }        

    for (cpt=0; cpt<size; cpt++)
    {
        weights[cpt]=new int[size];
        
        if (weights[cpt]==NULL)
        {
            cerr << "Error allocating memory" << endl;
            nb_neurons  =0;
            delete[] treshold;
            treshold    =NULL;
            delete[]  outputs;
            outputs     =NULL;
            for (tmp=0; tmp<cpt; tmp++)
            {
                delete[] weights[tmp];
            }
            delete[] weights;
            weights     =NULL;
            return;
        }
    }
    
    Set_Treshold();
}

CAssocmem::~CAssocmem()
{
    ULONG cpt;
    
    if (treshold!=NULL) /*We need to test just one, cause if one is, the others are too*/
    {
        delete[] treshold;
        delete[] outputs;
        for (cpt=0; cpt<nb_neurons; cpt++)
        {
            delete[] weights[cpt];
        }
        delete[] weights;
        
        treshold=NULL;
        outputs =NULL;
        weights =NULL;
        nb_neurons=0;
    }
}

/*****************************************/

void CAssocmem::Train(int** input, ULONG nb_patterns)
{
    ULONG cpt1;
    ULONG cpt2;
    ULONG nb;
    
    int cur_weight;
    
    for(cpt1=0; cpt1<nb_neurons; cpt1++)
    {
		for (cpt2=0; cpt2<nb_neurons; cpt2++)
		{
			cur_weight=0;

			if (cpt1 != cpt2)
			{
				for (nb=0; nb<nb_patterns; nb++)
				{
					cur_weight += _go_bipolar(input[nb][cpt1]) * _go_bipolar(input[nb][cpt2]);
				}
			}

			weights[cpt1][cpt2] = cur_weight;
		}
	}
}

/*****************************************/

void CAssocmem::Set_Treshold()
{
    ULONG cpt;
    
    if (treshold!=NULL)
    {
        for (cpt=0; cpt<nb_neurons; cpt++)
        {
            treshold[cpt]=0;
        }
    }
}

/*****************************************/

void CAssocmem::Process_Net()
{
    ULONG chosen_neuron;
    ULONG current;
    ULONG last;
    
    current =0;
    last    =0;
    
    do
    {
        current++;
        chosen_neuron=rand()%nb_neurons;
        
        if (Process_Neuron(chosen_neuron)==true)
        {
            last=current;
        }
    } while (current-last < 10*nb_neurons);
}

/*****************************************/

bool CAssocmem::Process_Neuron(ULONG number)
{
    ULONG cpt;
    int sum;
    int   result;
    bool is_changed;
    
    sum=0;
    is_changed=false;
    
    for (cpt=0; cpt<nb_neurons; cpt++)
    {
        sum+=weights[number][cpt]*outputs[cpt];
    }
    
    if (sum!=treshold[number])
    {
        if (sum>treshold[number]) result=1;
        else result=-1;
        
        if (result!=outputs[number])
        {
            is_changed=true;
            outputs[number]=result;
        }
    }
    
    return is_changed;
}

/*****************************************/

int* CAssocmem::Get_Outputs()
{
    ULONG cpt;
    for (cpt=0; cpt<nb_neurons; cpt++)
	{
        outputs[cpt]=_go_binary(outputs[cpt]);
	}
    return outputs;
}

/*****************************************/

void CAssocmem::Run(int* input)
{
    ULONG cpt;
    
    for (cpt=0; cpt<nb_neurons; cpt++)
    {
        outputs[cpt]=_go_bipolar(input[cpt]);
    }
	Process_Net();
}

/*****************************************/
/*                 EOF                   */
/*****************************************/